SDL_test_fuzzer.h File Reference
`#include <SDL3/SDL_stdinc.h>`
`#include <SDL3/SDL_begin_code.h>`
`#include <SDL3/SDL_close_code.h>`
Include dependency graph for SDL_test_fuzzer.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Functions

void | SDLTest_FuzzerInit (Uint64 execKey)
Uint8 | SDLTest_RandomUint8 (void)
Sint8 | SDLTest_RandomSint8 (void)
Uint16 | SDLTest_RandomUint16 (void)
Sint16 | SDLTest_RandomSint16 (void)
Sint32 | SDLTest_RandomSint32 (void)
Uint32 | SDLTest_RandomUint32 (void)
Uint64 | SDLTest_RandomUint64 (void)
Sint64 | SDLTest_RandomSint64 (void)
float | SDLTest_RandomUnitFloat (void)
double | SDLTest_RandomUnitDouble (void)
float | SDLTest_RandomFloat (void)
double | SDLTest_RandomDouble (void)
Uint8 | SDLTest_RandomUint8BoundaryValue (Uint8 boundary1, Uint8 boundary2, bool validDomain)
Uint16 | SDLTest_RandomUint16BoundaryValue (Uint16 boundary1, Uint16 boundary2, bool validDomain)
Uint32 | SDLTest_RandomUint32BoundaryValue (Uint32 boundary1, Uint32 boundary2, bool validDomain)
Uint64 | SDLTest_RandomUint64BoundaryValue (Uint64 boundary1, Uint64 boundary2, bool validDomain)
Sint8 | SDLTest_RandomSint8BoundaryValue (Sint8 boundary1, Sint8 boundary2, bool validDomain)
Sint16 | SDLTest_RandomSint16BoundaryValue (Sint16 boundary1, Sint16 boundary2, bool validDomain)
Sint32 | SDLTest_RandomSint32BoundaryValue (Sint32 boundary1, Sint32 boundary2, bool validDomain)
Sint64 | SDLTest_RandomSint64BoundaryValue (Sint64 boundary1, Sint64 boundary2, bool validDomain)
Sint32 | SDLTest_RandomIntegerInRange (Sint32 min, Sint32 max)
char * | SDLTest_RandomAsciiString (void)
char * | SDLTest_RandomAsciiStringWithMaximumLength (int maxLength)
char * | SDLTest_RandomAsciiStringOfSize (int size)
int | SDLTest_GetFuzzerInvocationCount (void)

## Function Documentation

## SDLTest_FuzzerInit()

void SDLTest_FuzzerInit | ( | Uint64 | execKey | ) |

Fuzzer functions of SDL test framework.

This code is a part of the SDL test library, not the main SDL library. Note: The fuzzer implementation uses a static instance of random context internally which makes it thread-UNsafe. Initializes the fuzzer for a test

Parameters

  execKey | Execution "Key" that initializes the random number generator uniquely for the test.

## SDLTest_GetFuzzerInvocationCount()

int SDLTest_GetFuzzerInvocationCount | ( | void |  | ) |

Get the invocation count for the fuzzer since last ...FuzzerInit.

Returns
  the invocation count.

## SDLTest_RandomAsciiString()

char * SDLTest_RandomAsciiString | ( | void |  | ) |

Generates random null-terminated string. The minimum length for the string is 1 character, maximum length for the string is 255 characters and it can contain ASCII characters from 32 to 126.

Note: Returned string needs to be deallocated.

Returns
  a newly allocated random string; or NULL if length was invalid or string could not be allocated.

## SDLTest_RandomAsciiStringOfSize()

char * SDLTest_RandomAsciiStringOfSize | ( | int | size | ) |

Generates random null-terminated string. The length for the string is defined by the size parameter. String can contain ASCII characters from 32 to 126.

Note: Returned string needs to be deallocated.

Parameters

  size | The length of the generated string

Returns
  a newly allocated random string; or NULL if size was invalid or string could not be allocated.

References size.

## SDLTest_RandomAsciiStringWithMaximumLength()

char * SDLTest_RandomAsciiStringWithMaximumLength | ( | int | maxLength | ) |

Generates random null-terminated string. The maximum length for the string is defined by the maxLength parameter. String can contain ASCII characters from 32 to 126.

Note: Returned string needs to be deallocated.

Parameters

  maxLength | The maximum length of the generated string.

Returns
  a newly allocated random string; or NULL if maxLength was invalid or string could not be allocated.

## SDLTest_RandomDouble()

double SDLTest_RandomDouble | ( | void |  | ) |

Returns
  a random double.

## SDLTest_RandomFloat()

float SDLTest_RandomFloat | ( | void |  | ) |

Returns
  a random float.

## SDLTest_RandomIntegerInRange()

Sint32 SDLTest_RandomIntegerInRange | ( | Sint32 | min,
|  | Sint32 | max )

Returns integer in range [min, max] (inclusive). Min and max values can be negative values. If Max in smaller than min, then the values are swapped. Min and max are the same value, that value will be returned.

Parameters

  min | Minimum inclusive value of returned random number
  max | Maximum inclusive value of returned random number

Returns
  a generated random integer in range

## SDLTest_RandomSint16()

Sint16 SDLTest_RandomSint16 | ( | void |  | ) |

Returns a random Sint16

Returns
  a generated signed integer

## SDLTest_RandomSint16BoundaryValue()

Sint16 SDLTest_RandomSint16BoundaryValue | ( | Sint16 | boundary1,
|  | Sint16 | boundary2,
|  | bool | validDomain )

Returns a random boundary value for Sint16 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomSint16BoundaryValue(-10, 20, true) returns -11, -10, 19 or 20 RandomSint16BoundaryValue(-100, -10, false) returns -101 or -9 RandomSint16BoundaryValue(SINT16_MIN, 99, false) returns 100 RandomSint16BoundaryValue(SINT16_MIN, SINT16_MAX, false) returns SINT16_MIN (== error value) with error set

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  a random boundary value for the given range and domain or SINT16_MIN with error set

## SDLTest_RandomSint32()

Sint32 SDLTest_RandomSint32 | ( | void |  | ) |

Returns a random integer

Returns
  a generated integer

## SDLTest_RandomSint32BoundaryValue()

Sint32 SDLTest_RandomSint32BoundaryValue | ( | Sint32 | boundary1,
|  | Sint32 | boundary2,
|  | bool | validDomain )

Returns a random boundary value for Sint32 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomSint32BoundaryValue(-10, 20, true) returns -11, -10, 19 or 20 RandomSint32BoundaryValue(-100, -10, false) returns -101 or -9 RandomSint32BoundaryValue(SINT32_MIN, 99, false) returns 100 RandomSint32BoundaryValue(SINT32_MIN, SINT32_MAX, false) returns SINT32_MIN (== error value)

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  a random boundary value for the given range and domain or SINT32_MIN with error set

## SDLTest_RandomSint64()

Sint64 SDLTest_RandomSint64 | ( | void |  | ) |

Returns random Sint64.

Returns
  a generated signed integer

## SDLTest_RandomSint64BoundaryValue()

Sint64 SDLTest_RandomSint64BoundaryValue | ( | Sint64 | boundary1,
|  | Sint64 | boundary2,
|  | bool | validDomain )

Returns a random boundary value for Sint64 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomSint64BoundaryValue(-10, 20, true) returns -11, -10, 19 or 20 RandomSint64BoundaryValue(-100, -10, false) returns -101 or -9 RandomSint64BoundaryValue(SINT64_MIN, 99, false) returns 100 RandomSint64BoundaryValue(SINT64_MIN, SINT64_MAX, false) returns SINT64_MIN (== error value) and error set

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  a random boundary value for the given range and domain or SINT64_MIN with error set

## SDLTest_RandomSint8()

Sint8 SDLTest_RandomSint8 | ( | void |  | ) |

Returns a random Sint8

Returns
  a generated signed integer

## SDLTest_RandomSint8BoundaryValue()

Sint8 SDLTest_RandomSint8BoundaryValue | ( | Sint8 | boundary1,
|  | Sint8 | boundary2,
|  | bool | validDomain )

Returns a random boundary value for Sint8 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomSint8BoundaryValue(-10, 20, true) returns -11, -10, 19 or 20 RandomSint8BoundaryValue(-100, -10, false) returns -101 or -9 RandomSint8BoundaryValue(SINT8_MIN, 99, false) returns 100 RandomSint8BoundaryValue(SINT8_MIN, SINT8_MAX, false) returns SINT8_MIN (== error value) with error set

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  a random boundary value for the given range and domain or SINT8_MIN with error set

## SDLTest_RandomUint16()

Uint16 SDLTest_RandomUint16 | ( | void |  | ) |

Returns a random Uint16

Returns
  a generated integer

## SDLTest_RandomUint16BoundaryValue()

Uint16 SDLTest_RandomUint16BoundaryValue | ( | Uint16 | boundary1,
|  | Uint16 | boundary2,
|  | bool | validDomain )

Returns a random boundary value for Uint16 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomUint16BoundaryValue(10, 20, true) returns 10, 11, 19 or 20 RandomUint16BoundaryValue(1, 20, false) returns 0 or 21 RandomUint16BoundaryValue(0, 99, false) returns 100 RandomUint16BoundaryValue(0, 0xFFFF, false) returns 0 (error set)

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  a random boundary value for the given range and domain or 0 with error set

## SDLTest_RandomUint32()

Uint32 SDLTest_RandomUint32 | ( | void |  | ) |

Returns a random positive integer

Returns
  a generated integer

## SDLTest_RandomUint32BoundaryValue()

Uint32 SDLTest_RandomUint32BoundaryValue | ( | Uint32 | boundary1,
|  | Uint32 | boundary2,
|  | bool | validDomain )

Returns a random boundary value for Uint32 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomUint32BoundaryValue(10, 20, true) returns 10, 11, 19 or 20 RandomUint32BoundaryValue(1, 20, false) returns 0 or 21 RandomUint32BoundaryValue(0, 99, false) returns 100 RandomUint32BoundaryValue(0, 0xFFFFFFFF, false) returns 0 (with error set)

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  a random boundary value for the given range and domain or 0 with error set

## SDLTest_RandomUint64()

Uint64 SDLTest_RandomUint64 | ( | void |  | ) |

Returns random Uint64.

Returns
  a generated integer

## SDLTest_RandomUint64BoundaryValue()

Uint64 SDLTest_RandomUint64BoundaryValue | ( | Uint64 | boundary1,
|  | Uint64 | boundary2,
|  | bool | validDomain )

Returns a random boundary value for Uint64 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomUint64BoundaryValue(10, 20, true) returns 10, 11, 19 or 20 RandomUint64BoundaryValue(1, 20, false) returns 0 or 21 RandomUint64BoundaryValue(0, 99, false) returns 100 RandomUint64BoundaryValue(0, 0xFFFFFFFFFFFFFFFF, false) returns 0 (with error set)

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  a random boundary value for the given range and domain or 0 with error set

## SDLTest_RandomUint8()

Uint8 SDLTest_RandomUint8 | ( | void |  | ) |

Returns a random Uint8

Returns
  a generated integer

## SDLTest_RandomUint8BoundaryValue()

Uint8 SDLTest_RandomUint8BoundaryValue | ( | Uint8 | boundary1,
|  | Uint8 | boundary2,
|  | bool | validDomain )

Returns a random boundary value for Uint8 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomUint8BoundaryValue(10, 20, true) returns 10, 11, 19 or 20 RandomUint8BoundaryValue(1, 20, false) returns 0 or 21 RandomUint8BoundaryValue(0, 99, false) returns 100 RandomUint8BoundaryValue(0, 255, false) returns 0 (error set)

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  a random boundary value for the given range and domain or 0 with error set

## SDLTest_RandomUnitDouble()

double SDLTest_RandomUnitDouble | ( | void |  | ) |

Returns
  a random double in range [0.0 - 1.0]

## SDLTest_RandomUnitFloat()

float SDLTest_RandomUnitFloat | ( | void |  | ) |

Returns
  a random float in range [0.0 - 1.0]